module.exports = function(components){
    if(!components){
        components = {};
    }

    var genericComponent = require('../genericComponent'),
        textComponent = require('../textComponent');

    // dont do fancy requestAnimationFrame scheduling that is hard to test.
    genericComponent.updateProperty = function(generic, property, update){
        update();
    };

    genericComponent.createElement = function(tagName){
        if(tagName instanceof Node){
            return tagName;
        }
        return document.createElement(tagName);
    };

    textComponent.createTextNode = document.createTextNode.bind(document);

    components._generic = genericComponent;
    components.list = require('../listComponent');
    components.templater = require('../templaterComponent');
    components.text = textComponent;

    return components;
};