module.exports = function(){
    var domLite = require('dom-lite'),
        eventNames = require('./eventNames');

    document = domLite.document;
    document.body = document.createElement('body');
    Node = domLite.Node;

    Object.defineProperty(domLite.HTMLElement.prototype, 'value', {
        get: function() {
            return this._value;
        },
        set: function(value) {
            this._value = (value == null ? '' : value).toString();
        }
    });
    
    domLite.HTMLElement.prototype.value = null;

    domLite.Node.prototype.remove = function(){
        if(this.parentNode){
            this.parentNode.removeChild(this);
        }
    };

    domLite.Node.prototype.addEventListener = function(eventName, handler){
        this._events = this._events || {};
        this._events[eventName] = this._events[eventName] || [];
        this._events[eventName].push(handler);
    };
    domLite.Node.prototype.removeEventListener = function(eventName, handler){
        this._events && this._events[eventName] && this._events[eventName].splice(
            this._events[eventName].indexOf(handler), 1
        );
    };

    domLite.Node.prototype._emit = function(eventName){
        this._events && this._events[eventName] && this._events[eventName].map(function(handler){
            handler({target: this});
        }, this);
    };

    domLite.Node.prototype.click = function(){
        this._emit('click');
    };

    eventNames.map(function(eventName){
        domLite.Node.prototype[eventName] = undefined;
    });

    global.document = document;
};