var test = require('tape'),
    crel = require('crel'),
    fancyProps = require('../fancyProps');

test('date input', function(t){

    t.plan(2);

    var input = crel('input', {type: 'date'});

    t.equal(fancyProps.value({}, input), null);

    fancyProps.value({}, input, new Date('2000-1-1'));

    t.equal(fancyProps.value({}, input).toString(), new Date('2000-1-1').toString());
});

test('class', function(t){

    t.plan(3);

    var component = {},
        span = crel('span');

    t.equal(fancyProps.class(component, span), '');

    fancyProps.class(component, span, 'foo');

    t.equal(fancyProps.class(component, span), 'foo');

    fancyProps.class(component, span, ['bar']);

    t.equal(fancyProps.class(component, span), 'bar');
});

test('class 2', function(t){

    t.plan(6);

    var component = {},
        span = crel('span', {class: 'majigger'});

    t.equal(fancyProps.class(component, span), '');
    t.equal(span.className, 'majigger');

    fancyProps.class(component, span, 'foo');

    t.equal(fancyProps.class(component, span), 'foo');
    t.equal(span.className, 'majigger foo');

    span.className += ' whatsits';

    fancyProps.class(component, span, ['bar']);

    t.equal(fancyProps.class(component, span), 'bar');
    t.equal(span.className, 'majigger whatsits bar');
});